#ifndef TIMEBPIPEOUTPUT_H
#define TIMEBPIPEOUTPUT_H

// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of mergerays
//
// mergerays is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// mergerays is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include "BpipeOutput.h"

#include <cxcparamx/simple.h>

class TimeBpipeOutput : public BpipeOutput {

public:

    TimeBpipeOutput( BpipeInput& input,
                     const std::string& output,
                     const std::vector<std::string>& xfer_fields );

    void write_dpkts();

protected:

    size_t copy_data( size_t i );

private:

    size_t num;

    //: points to the ith element of output_data_fields where
    //: its name is equal to BP_AXAF_time.
    //: non-owning pointer
    DataField* time_datafield;

    bool is_time_present( );
    //: Make sure that the time field is present for all the input stream.
    //  The method returns EXIT_SUCCESS or EXIT_FAILURE if the field is
    //  present in all of the input streams or if the time field is missing
    //  in one of the input streams, respectively.

};

#endif
